# include "sandia_rules.H"

# include <cstdlib>
# include <iomanip>
# include <iostream>
# include <cmath>

int main ( );
void test01 ( );
void test02 ( );
void test03 ( );
void test04 ( );
void test05 ( );
void test06 ( );
void test07 ( );
void test08 ( );
void test09 ( );
void test10 ( );
void test11 ( );
void test12 ( );
void test13 ( );
void test14 ( );
void test15 ( );
void test16 ( );
void test17 ( );
void test18 ( );
void test19 ( );
void test20 ( );
void test21 ( );
void test22 ( );
void test23 ( int r );
void test24 ( );
void test25 ( );
void test26 ( );
void test27 ( );
void test28 ( );
void test285 ( );
void test29 ( );
void test30 ( );

void test01_np ( );
void test02_np ( );
void test03_np ( );
void test04_np ( );
void test05_np ( );
void test06_np ( );
void test07_np ( );
void test08_np ( );
void test09_np ( );
void test10_np ( );
void test11_np ( );
void test12_np ( );
void test13_np ( );
void test14_np ( );
void test15_np ( );
void test16_np ( );
void test17_np ( );
void test18_np ( );
void test19_np ( );
void test20_np ( );
void test21_np ( );
void test22_np ( );

//****************************************************************************80

int main ( )

//****************************************************************************80
//
//  Purpose:
//
//    MAIN is the main program for SANDIA_RULES_PRB.
//
//  Discussion:
//
//    SANDIA_RULES_PRB calls a set of tests for the SANDIA_RULES library.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    09 October 2010
//
//  Author:
//
//    John Burkardt
//
{
  int r;

  webbur::timestamp ( );

  std::cout << "\n";
  std::cout << "SANDIA_RULES_PRB\n";
  std::cout << "  C++ version\n";
  std::cout << "\n";
  std::cout << "  Test the SANDIA_RULES library.\n";

  test01 ( );
  test02 ( );
  test03 ( );
  test04 ( );
  test05 ( );
  test06 ( );
  test07 ( );
  test08 ( );
  test09 ( );

  test10 ( );
  test11 ( );
  test12 ( );
  test13 ( );
  test14 ( );
  test15 ( );
  test16 ( );
  test17 ( );
  test18 ( );
  test19 ( );

  test20 ( );
  test21 ( );
  test22 ( );
//
//  TEST23 takes an input argument of R, a rule index.
//
  r = 1;
  test23 ( r );
  r = 3;
  test23 ( r );
  r = 4;
  test23 ( r );
  r = 11;
  test23 ( r );

  test24 ( );
  test25 ( );
  test26 ( );
  test27 ( );
  test28 ( );
  test285 ( );
  test29 ( );

  test30 ( );
//
//  Repeat tests, but now call "NP" versions of routines.
//
  test01_np ( );
  test02_np ( );
  test03_np ( );
  test04_np ( );
  test05_np ( );
  test06_np ( );
  test07_np ( );
  test08_np ( );
  test09_np ( );

  test10_np ( );
  test11_np ( );
  test12_np ( );
  test13_np ( );
  test14_np ( );
  test15_np ( );
  test16_np ( );
  test17_np ( );
  test18_np ( );
  test19_np ( );

  test20_np ( );
  test21_np ( );
  test22_np ( );
//
//  Terminate.
//
  std::cout << "\n";
  std::cout << "SANDIA_RULES_PRB\n";
  std::cout << "  Normal end of execution.\n";

  std::cout << "\n";
  webbur::timestamp ( );
 
  return 0;
}
//****************************************************************************80

void test01 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST01 tests CHEBYSHEV1_COMPUTE against CHEBYSHEV1_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST01\n";
  std::cout << "  CHEBYSHEV1_COMPUTE computes a Gauss-Chebyshev type 1 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) / sqrt ( 1 - x^2 ) dx.\n";
  std::cout << "\n";
  std::cout << "  CHEBYSHEV1_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::chebyshev1_compute ( order, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::chebyshev1_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
                << "  " << std::setw(8)  << n
                << "  " << std::setprecision(6) << std::setw(14) << estimate
                << "  " << std::setprecision(6) << std::setw(14) << exact
                << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test02 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST02 tests CHEBYSHEV1_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST02\n";
  std::cout << "  CHEBYSHEV1_COMPUTE computes a Gauss-Chebyshev type 1 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) / sqrt(1-x^2) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::chebyshev1_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test03 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST03 tests CHEBYSHEV2_COMPUTE against CHEBYSHEV2_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST03\n";
  std::cout << "  CHEBYSHEV2_COMPUTE computes a Gauss-Chebyshev type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) * sqrt ( 1 - x^2 ) dx.\n";
  std::cout << "\n";
  std::cout << "  CHEBYSHEV2_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::chebyshev2_compute ( order, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::chebyshev2_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test04 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST04 tests CHEBYSHEV2_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST04\n";
  std::cout << "  CHEBYSHEV2_COMPUTE computes a Gauss-Chebyshev type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) * sqrt(1-x^2) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::chebyshev2_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test05 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST05 tests CLENSHAW_CURTIS_COMPUTE against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int n_hi;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST05\n";
  std::cout << "  CLENSHAW_CURTIS_COMPUTE computes a Clenshaw Curtis rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N up to\n";
  std::cout << "    N = ORDER+1 if ORDER is odd, or\n";
  std::cout << "    N = ORDER   if ORDER is even\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::clenshaw_curtis_compute ( order, x, w );

    if ( ( order % 2 ) == 0 )
    {
      n_hi = order + 2;
    }
    else
    {
      n_hi = order + 3;
    }

    for ( n = 0; n <= n_hi; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
                << "  " << std::setw(8)  << n
                << "  " << std::setprecision(6) << std::setw(14) << estimate
                << "  " << std::setprecision(6) << std::setw(14) << exact
                << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test06 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST06 tests CLENSHAW_CURTIS_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST06\n";
  std::cout << "  CLENSHAW_CURTIS_COMPUTE computes a Clenshaw Curtis rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::clenshaw_curtis_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test07 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST07 tests FEJER2_COMPUTE against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int n_hi;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST07\n";
  std::cout << "  FEJER2_COMPUTE computes a Fejer Type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N up to\n";
  std::cout << "    N = ORDER+1 if ORDER is odd, or\n";
  std::cout << "    N = ORDER   if ORDER is even\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::fejer2_compute ( order, x, w );

    if ( ( order % 2 ) == 0 )
    {
      n_hi = order + 2;
    }
    else
    {
      n_hi = order + 3;
    }

    for ( n = 0; n <= n_hi; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test08 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST08 tests FEJER2_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST08\n";
  std::cout << "  FEJER2_COMPUTE computes a Fejer Type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::fejer2_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test09 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST09 tests GEGENBAUER_COMPUTE against GEGENBAUER_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST09\n";
  std::cout << "  GEGENBAUER_COMPUTE computes a generalized Gauss-Gegenbauer rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) (1-x^2)^alpha dx.\n";
  std::cout << "\n";
  std::cout << "  GEGENBAUER_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gegenbauer_compute ( order, alpha, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gegenbauer_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test10 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST10 tests GEGENBAUER_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST10\n";
  std::cout << "  GEGENBAUER_COMPUTE computes a generalized Gauss-Gegenbauer rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x^2)^alpha dx.\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gegenbauer_compute ( order, alpha, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test11 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST11 tests GEN_HERMITE_COMPUTE against GEN_HERMITE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST11\n";
  std::cout << "  GEN_HERMITE_COMPUTE computes a generalized Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) x^alpha exp(-x*x) dx.\n";
  std::cout << "\n";
  std::cout << "  GEN_HERMITE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gen_hermite_compute ( order, alpha, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gen_hermite_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setprecision(6) << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test12 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST12 tests GEN_HERMITE_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST12\n";
  std::cout << "  GEN_HERMITE_COMPUTE computes a generalized Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) x^alpha exp(-x*x) dx.\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gen_hermite_compute ( order, alpha, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test13 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST13 tests GEN_LAGUERRE_COMPUTE against GEN_LAGUERRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST13\n";
  std::cout << "  GEN_LAGUERRE_COMPUTE computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) x^alpha exp(-x) dx.\n";
  std::cout << "\n";
  std::cout << "  GEN_LAGUERRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gen_laguerre_compute ( order, alpha, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gen_laguerre_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setprecision(6) << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test14 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST14 tests GEN_LAGUERRE_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST14\n";
  std::cout << "  GEN_LAGUERRE_COMPUTE computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) x^alpha exp(-x) dx.\n";

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gen_laguerre_compute ( order, alpha, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test15 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST15 tests HERMITE_COMPUTE against HERMITE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST15\n";
  std::cout << "  HERMITE_COMPUTE computes a Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) exp(-x*x) dx.\n";
  std::cout << "\n";
  std::cout << "  HERMITE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::hermite_compute ( order, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::hermite_integral ( n );
 
      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test16 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST16 tests HERMITE_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST16\n";
  std::cout << "  HERMITE_COMPUTE computes a Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) exp(-x*x) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::hermite_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test17 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST17 tests JACOBI_COMPUTE against JACOBI_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double beta;
  double beta_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  int test1;
  int test2;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST17\n";
  std::cout << "  JACOBI_COMPUTE computes a Gauss-Jacobi rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x)^alpha (1+x)^beta dx.\n";
  std::cout << "\n";
  std::cout << "  JACOBI_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Beta            Estimate       Exact            Error\n";

  for ( test1 = 0; test1 < TEST_NUM; test1++ )
  {
    alpha = alpha_test[test1];

    for ( test2 = 0; test2 < TEST_NUM; test2++ )
    {
      beta = beta_test[test2];

      for ( order = 1; order <= order_max; order++ )
      {
        std::cout << "\n";

        f = new double[order];
        w = new double[order];
        x = new double[order];

        webbur::jacobi_compute ( order, alpha, beta, x, w );

        for ( n = 0; n <= 2 * order + 2; n = n + 1 )
        {
          exact = webbur::jacobi_integral ( n, alpha, beta );
 
          if ( n == 0 )
          {
            for ( i = 0; i < order; i++ )
            {
              f[i] = 1.0;
            }
          }
          else
          {
            for ( i = 0; i < order; i++ )
            {
              f[i] = std::pow ( x[i], n );
            }
          }
          estimate = 0.0;
          for ( i = 0; i < order; i++ )
          {
            estimate = estimate + w[i] * f[i];
          }
 
          error = webbur::r8_abs ( exact - estimate );
  
          std::cout << "  " << std::setw(8)  << order
               << "  " << std::setw(8)  << n
               << "  " << std::setprecision(6) << std::setw(14) << alpha
               << "  " << std::setprecision(6) << std::setw(14) << beta
               << "  " << std::setprecision(6) << std::setw(14) << estimate
               << "  " << std::setprecision(6) << std::setw(14) << exact
               << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
        }
        delete [] f;
        delete [] w;
        delete [] x;
      }
    }
  }
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test18 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST18 tests JACOBI_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double beta;
  double beta_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int order;
  int order_max = 10;
  int test1;
  int test2;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST18\n";
  std::cout << "  JACOBI_COMPUTE computes a Gauss-Jacobi rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x)^alpha (1+x)^beta dx.\n";

  for ( test1 = 0; test1 < TEST_NUM; test1++ )
  {
    alpha = alpha_test[test1];

    for ( test2 = 0; test2 < TEST_NUM; test2++ )
    {
      beta = beta_test[test2];

      for ( order = 1; order <= order_max; order++ )
      {
        std::cout << "\n";
        std::cout << "  Order = " << order << "\n";
        std::cout << "  ALPHA = " << alpha << "\n";
        std::cout << "  BETA = "  << beta << "\n";

        w = new double[order];
        x = new double[order];

        webbur::jacobi_compute ( order, alpha, beta, x, w );

        for ( i = 0; i < order; i =i + 1 )
        {
          std::cout << "  " << std::setw(8) << i
                    << "  " << std::setprecision(16) << std::setw(24) << x[i]
                    << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
        }
        delete [] w;
        delete [] x;
      }
    }
  }
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test19 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST19 tests LAGUERRE_COMPUTE against LAGUERRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST19\n";
  std::cout << "  LAGUERRE_COMPUTE computes a Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) exp(-x) dx.\n";
  std::cout << "\n";
  std::cout << "  LAGUERRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::laguerre_compute ( order, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::laguerre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test20 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST20 tests LAGUERRE_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST20\n";
  std::cout << "  LAGUERRE_COMPUTE computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) exp(-x) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::laguerre_compute ( order, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test21 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST21 tests LEGENDRE_COMPUTE against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int order;
  int order_max = 10;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST21\n";
  std::cout << "  LEGENDRE_COMPUTE computes a Gauss-Legendre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::legendre_compute ( order, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test22 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST22 tests LEGENDRE_COMPUTE.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    13 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int order;
  int order_max = 10;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST22\n";
  std::cout << "  LEGENDRE_COMPUTE computes a Gauss-Legendre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::legendre_compute ( order, x, w );
 
    for ( i = 0; i < order; i++ )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  return;
}
//****************************************************************************80

void test23 ( int r )

//****************************************************************************80
//
//  Purpose:
//
//    TEST23 tests LEVEL_GROWTH_TO_ORDER.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    08 June 2010
//
//  Author:
//
//    John Burkardt
//
//  Parameters:
//
//    Input, int R, the index of the rule to be examined.
//
{
  int dim;
  int dim_num = 11;
  int g;
  int *growth;
  int *level;
  int *order;
  int *rule;

  std::cout << "\n";
  std::cout << "TEST23\n";
  std::cout << "  LEVEL_GROWTH_TO_ORDER uses Level, Growth and Rule\n";
  std::cout << "  to determine the orders of each entry of a vector of 1D rules.\n";
  std::cout << "\n";
  std::cout << "  Here we examine rule " << r << ".\n";
  std::cout << "\n";
  std::cout << 
    "       LEVEL:0     1     2     3     4     5     6     7     8     9    10\n";
  std::cout << "GROWTH\n";

  growth = new int[dim_num];
  level = new int[dim_num];
  order = new int[dim_num];
  rule = new int[dim_num];

  for ( dim = 0; dim < dim_num; dim++ )
  {
    rule[dim] = r;
  }

  for ( g = 0; g <= 6; g++ )
  {
    if ( r == 3 || r == 11 )
    {
      if ( g == 1 || g == 2 || g == 3 )
      {
        continue;
      }
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      level[dim] = dim;
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      growth[dim] = g;
    }
    webbur::level_growth_to_order ( dim_num, level, rule, growth, order );

    std::cout << "  " << std::setw(4) << g << "  ";
 
    for ( dim = 0; dim < dim_num; dim++ )
    {
      std::cout << "  " << std::setw(4) << order[dim];
    }
    std::cout << "\n";
  }

  delete [] growth;
  delete [] level;
  delete [] order;
  delete [] rule;
 
  return;
}
//****************************************************************************80

void test24 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST24 tests LEVEL_TO_ORDER_DEFAULT.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    11 February 2010
//
//  Author:
//
//    John Burkardt
//
{
  int dim;
  int dim_num = 11;
  int *level;
  int *order;
  int r;
  int *rule;

  std::cout << "\n";
  std::cout << "TEST24\n";
  std::cout << "  LEVEL_TO_ORDER_DEFAULT uses a default rule to\n";
  std::cout << "  determine the order of a rule from its level.\n";
  std::cout << "\n";
  std::cout << 
    "RULE/LEVEL   0     1     2     3     4     5     6     7     8     9    10\n";
  std::cout << "\n";

  level = new int[dim_num];
  order = new int[dim_num];
  rule = new int[dim_num];

  for ( r = 1; r <= 16; r++ )
  {
    for ( dim = 0; dim < dim_num; dim++ )
    {
      rule[dim] = r;
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      level[dim] = dim;
    }
    webbur::level_to_order_default ( dim_num, level, rule, order );

    std::cout << "  " << std::setw(4) << r << "  ";
 
    for ( dim = 0; dim < dim_num; dim++ )
    {
      std::cout << "  " << std::setw(4) << order[dim];
    }
    std::cout << "\n";
  }

  delete [] level;
  delete [] order;
  delete [] rule;
 
  return;
}
//****************************************************************************80

void test25 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST25 tests LEVEL_TO_ORDER_EXPONENTIAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    17 December 2009
//
//  Author:
//
//    John Burkardt
//
{
  int dim;
  int dim_num = 11;
  int *level;
  int *order;
  int r;
  int *rule;

  std::cout << "\n";
  std::cout << "TEST25\n";
  std::cout << "  LEVEL_TO_ORDER_EXPONENTIAL uses an exponential rule to\n";
  std::cout << "  determine the order of a rule from its level.\n";
  std::cout << "\n";
  std::cout << 
    "RULE/LEVEL   0     1     2     3     4     5     6     7     8     9    10\n";
  std::cout << "\n";

  level = new int[dim_num];
  order = new int[dim_num];
  rule = new int[dim_num];

  for ( r = 1; r <= 10; r++ )
  {
    for ( dim = 0; dim < dim_num; dim++ )
    {
      rule[dim] = r;
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      level[dim] = dim;
    }
    webbur::level_to_order_exponential ( dim_num, level, rule, order );

    std::cout << "  " << std::setw(4) << r << "  ";
 
    for ( dim = 0; dim < dim_num; dim++ )
    {
      std::cout << "  " << std::setw(4) << order[dim];
    }
    std::cout << "\n";
  }

  delete [] level;
  delete [] order;
  delete [] rule;
 
  return;
}
//****************************************************************************80

void test26 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST26 tests LEVEL_TO_ORDER_EXPONENTIAL_SLOW.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    17 December 2009
//
//  Author:
//
//    John Burkardt
//
{
  int dim;
  int dim_num = 11;
  int *level;
  int *order;
  int r;
  int *rule;

  std::cout << "\n";
  std::cout << "TEST26\n";
  std::cout << "  LEVEL_TO_ORDER_EXPONENTIAL_SLOW uses a slow exponential rule to\n";
  std::cout << "  determine the order of a rule from its level.\n";
  std::cout << "\n";
  std::cout << "  Since it is really only useful for fully nested rules,\n";
  std::cout << "  we only consider rules 11, 12 and 13.\n";
  std::cout << "\n";
  std::cout << 
    "RULE/LEVEL   0     1     2     3     4     5     6     7     8     9    10\n";
  std::cout << "\n";

  level = new int[dim_num];
  order = new int[dim_num];
  rule = new int[dim_num];

  for ( r = 11; r <= 13; r++ )
  {
    for ( dim = 0; dim < dim_num; dim++ )
    {
      rule[dim] = r;
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      level[dim] = dim;
    }
    webbur::level_to_order_exponential_slow ( dim_num, level, rule, order );

    std::cout << "  " << std::setw(4) << r << "  ";
 
    for ( dim = 0; dim < dim_num; dim++ )
    {
      std::cout << "  " << std::setw(4) << order[dim];
    }
    std::cout << "\n";
  }

  delete [] level;
  delete [] order;
  delete [] rule;
 
  return;
}
//****************************************************************************80

void test27 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST27 tests LEVEL_TO_ORDER_LINEAR.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    17 December 2009
//
//  Author:
//
//    John Burkardt
//
{
  int dim;
  int dim_num = 11;
  int *level;
  int *order;
  int r;
  int *rule;

  std::cout << "\n";
  std::cout << "TEST27\n";
  std::cout << "  LEVEL_TO_ORDER_LINEAR uses a linear rule to\n";
  std::cout << "  determine the order of a rule from its level.\n";
  std::cout << "\n";
  std::cout << 
    "RULE/LEVEL   0     1     2     3     4     5     6     7     8     9    10\n";
  std::cout << "\n";

  level = new int[dim_num];
  order = new int[dim_num];
  rule = new int[dim_num];

  for ( r = 1; r <= 10; r++ )
  {
    for ( dim = 0; dim < dim_num; dim++ )
    {
      rule[dim] = r;
    }
    for ( dim = 0; dim < dim_num; dim++ )
    {
      level[dim] = dim;
    }
    webbur::level_to_order_linear ( dim_num, level, rule, order );

    std::cout << "  " << std::setw(4) << r << "  ";
 
    for ( dim = 0; dim < dim_num; dim++ )
    {
      std::cout << "  " << std::setw(4) << order[dim];
    }
    std::cout << "\n";
  }

  delete [] level;
  delete [] order;
  delete [] rule;
 
  return;
}
//****************************************************************************80

void test28 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST28 tests PATTERSON_LOOKUP against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    11 February 2010
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int level;
  int level_max = 5;
  int n;
  int order;
  int p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST28\n";
  std::cout << "  PATTERSON_LOOKUP computes a Gauss-Patterson rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = (3*ORDER+1)/2\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  for ( level = 0; level <= level_max; level++ )
  {
    order = webbur::i4_power ( 2, level + 1 ) - 1;

    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::patterson_lookup ( order, x, w );

    if ( order == 1 )
    {
      p = 1;
    }
    else
    {
      p = ( 3 * order + 1 ) / 2;
    }

    for ( n = 0; n <= p + 3; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
  return;
}
//****************************************************************************80

void test285 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST285 tests POINT_RADIAL_TOL_UNIQUE_INDEX_INC1, INC2 and INC3.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    09 October 2010
//
//  Author:
//
//    John Burkardt
//
{
# define M 2
# define N1 11
# define N2 8

  int m = M;
  int n1 = N1;
  int n2 = N2;

  double a1[M*N1] = {
    0.0, 0.0, 
    0.5, 0.5, 
    1.0, 0.0, 
    0.0, 1.0, 
    1.0, 1.0, 
    0.500000001, 0.5, 
    0.0, 0.0, 
    0.0, 0.5, 
    0.5, 0.0, 
    1.0, 0.5, 
    0.5, 1.0 };
  double a2[M*N2] = {
    0.4999999999, 0.5, 
    0.75,        0.25, 
    0.500000001, 0.9999999999, 
    0.500000001, 0.0000000001, 
    0.25,        0.75, 
    0.75,        0.25, 
    0.250000001, 0.7499999999, 
    0.75,        0.75 };
  double *a3;
  int i1;
  int i2;
  int i3;
  int *indx1;
  int *indx2;
  int *indx3;
  int j;
  int n3;
  double *r1;
  double *r2;
  double *r3;
  int seed;
  double tol;
  int undx_value;
  int *undx1;
  int *undx2;
  int *undx3;
  int unique_num1;
  int unique_num2;
  int unique_num3;
  bool *unique1;
  bool *unique2;
  bool *unique3;
  int *xdnu1;
  int *xdnu2;
  int *xdnu3;
  double *z;

  seed = 123456789;

  std::cout << "\n";
  std::cout << "TEST285\n";
  std::cout << "  POINT_RADIAL_TOL_UNIQUE_INDEX_INC1 can index unique\n";
  std::cout << "  points in a \"permanent\" point set;\n";
  std::cout << "  POINT_RADIAL_TOL_UNIQUE_INDEX_INC2 can incremented by\n";
  std::cout << "  \"temporary\" points.\n";
  std::cout << "  POINT_RADIAL_TOL_UNIQUE_INDEX_INC3 can merge permanent\n";
  std::cout << "  and temporary points.\n";

  tol = std::sqrt ( webbur::r8_epsilon ( ) );
  std::cout << "  Using tolerance TOL = " << tol << "\n";
//
//  Step 1
//
  indx1 = new int[n1];
  r1 = new double[n1];
  undx1 = new int[n1];
  unique1 = new bool[n1];
  xdnu1 = new int[n1];
  z = new double[m];

  webbur::point_radial_tol_unique_index_inc1 ( m, n1, a1, tol, &seed, z, r1,
    indx1, unique1, &unique_num1, undx1, xdnu1 );

  std::cout << "\n";
  std::cout << "  UNIQUE_NUM1 = " << unique_num1 << "\n";
  std::cout << "  Expected   =  " << 9 << "\n";

  std::cout << "\n";
  std::cout << "  Item I1, unique index XDNU1[I1], representative location UNDX1[XDNU1[I1]]:\n";
  std::cout << "\n";
  std::cout << "           I1  XDNU1  UNDX1\n";
  std::cout << "\n";
  for ( i1 = 0; i1 < n1; i1++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i1
              << "  " << std::setw(4) << xdnu1[i1]
              << "  " << std::setw(4) << undx1[xdnu1[i1]] << "\n";
  }

  std::cout << "\n";
  std::cout << "  Unique item I1, location UNDX1(I1), value A1(:,UNDX1(I1)):\n";
  std::cout << "\n";
  std::cout << "          I1 UNDX1  --A1(1,*)---  --A1(2,*)---\n";
  std::cout << "\n";
  for ( i1 = 0; i1 < unique_num1; i1++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i1
              << "  " << std::setw(4) << undx1[i1]
              << "  " << std::setw(12) << a1[0+undx1[i1]*m]
              << "  " << std::setw(12) << a1[1+undx1[i1]*m] << "\n";
  }
  std::cout << "\n";
  std::cout << "  Unique item I1, location UNDX1(I1), value A1(:,UNDX1(I1)):\n";
  std::cout << "\n";
  std::cout << "          I1 UNIQUE1       R1     --A1(1,I1)--  --A1(2,I1)--\n";
  std::cout << "\n";
  for ( i1 = 0; i1 < n1; i1++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i1
              << "  " << std::setw(4) << unique1[i1]
              << "  " << std::setw(12) << r1[i1]
              << "  " << std::setw(12) << a1[0+i1*m]
              << "  " << std::setw(12) << a1[1+i1*m] << "\n";
  }
  std::cout << "\n";
  std::cout << "          I1   INDX1   R1(INDX1)\n";
  std::cout << "\n";
  for ( i1 = 0; i1 < n1; i1++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i1
              << "  " << std::setw(4) << indx1[i1]
              << "  " << std::setw(12) << r1[indx1[i1]] << "\n";
  }
//
//  Step 2
//
  indx2 = new int[n2];
  r2 = new double[n2];
  undx2 = new int[n2];
  unique2 = new bool[n2];
  xdnu2 = new int[n2];

  webbur::point_radial_tol_unique_index_inc2 ( m, n1, a1, n2, a2, tol, z, 
    r1, indx1, unique1,  unique_num1, undx1, xdnu1, 
    r2, indx2, unique2, &unique_num2, undx2, xdnu2 );

  std::cout << "\n";
  std::cout << "  UNIQUE_NUM2 = " << unique_num2 << "\n";
  std::cout << "  Expected   =  " << 3 << "\n";

  std::cout << "\n";
  std::cout << "  Item I2, unique index XDNU2[I2], representative location UNDX2[XDNU2[I2]]:\n";
  std::cout << "\n";
  std::cout << "    I2 XDNU2 UNDX2\n";
  std::cout << "\n";
  std::cout << "  (Temporary data)\n";
  std::cout << "\n";
  for ( i2 = 0; i2 < n2; i2++ )
  {
    if ( xdnu2[i2] < unique_num1 )
    {
      undx_value = undx1[xdnu2[i2]];
    }
    else
    {
      undx_value = undx2[ xdnu2[i2] - unique_num1 ];
    }
    std::cout << "  " << std::setw(4) << i2
              << "  " << std::setw(4) << i2 + n1
              << "  " << std::setw(4) << xdnu2[i2]
              << "  " << std::setw(4) << undx_value << "\n";
  }
  std::cout << "\n";
  std::cout << "  Unique item I2, location UNDX2(I2), value A2(:,UNDX2(I2)):\n";
  std::cout << "\n";
  std::cout << "    I2 UNDX2  --A2(1,*)---  --A2(2,*)---\n";
  std::cout << "\n";
  std::cout << "  (Temporary data)\n";
  std::cout << "\n";
  for ( i2 = 0; i2 < unique_num2; i2++ )
  {
    std::cout << "  " << std::setw(4) << i2
              << "  " << std::setw(4) << i2 + unique_num1
              << "  " << std::setw(4) << undx2[i2]
              << "  " << std::setw(12) << a2[0+(undx2[i2]-n1)*m]
              << "  " << std::setw(12) << a2[1+(undx2[i2]-n1)*m] << "\n";
  }
//
//  Step 3.
//
  std::cout << "\n";
  std::cout << "  Merge the temporary data with the permanent data.\n";

  a3 = new double[m*(n1+n2)];
  indx3 = new int[n1+n2];
  r3 = new double[n1+n2];
  undx3 = new int[n1+n2];
  unique3 = new bool[n1+n2];
  xdnu3 = new int[n1+n2];

  webbur::point_radial_tol_unique_index_inc3 ( m, 
     n1, a1, r1, indx1, unique1,  unique_num1, undx1, xdnu1, 
     n2, a2, r2, indx2, unique2,  unique_num2, undx2, xdnu2, 
    &n3, a3, r3, indx3, unique3, &unique_num3, undx3, xdnu3 );

  std::cout << "\n";
  std::cout << "  UNIQUE_NUM3 = " << unique_num3 << "\n";
  std::cout << "  Expected   =  12\n";

  std::cout << "\n";
  std::cout << "  Item I3, unique index XDNU3[I3], representative location UNDX3[XDNU3[I3]]:\n";
  std::cout << "\n";
  std::cout << "          I3 XDNU3 UNDX3\n";
  std::cout << "\n";
  for ( i3 = 0; i3 < n3; i3++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i3
              << "  " << std::setw(4) << xdnu3[i3]
              << "  " << std::setw(4) << undx3[xdnu3[i3]] << "\n";
  }
  std::cout << "\n";
  std::cout << "  Unique item I3, location UNDX3(I3), value A3(:,UNDX3(I3)):\n";
  std::cout << "\n";
  std::cout << "          I3 UNDX3  --A3(1,*)---  --A3(2,*)---\n";
  std::cout << "\n";
  for ( i3 = 0; i3 < unique_num3; i3++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i3
              << "  " << std::setw(4) << undx3[i3]
              << "  " << std::setw(12) << a3[0+undx3[i3]*m]
              << "  " << std::setw(12) << a3[1+undx3[i3]*m] << "\n";
  }
  std::cout << "\n";
  std::cout << "  Unique item I3, location UNDX3(I3), value A3(:,UNDX3(I3)):\n";
  std::cout << "\n";
  std::cout << "          I3 UNIQUE3       R3     --A3(1,I3)--  --A3(2,I3)--\n";
  std::cout << "\n";
  for ( i3 = 0; i3 < n3; i3++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i3
              << "  " << std::setw(4) << unique3[i3]
              << "  " << std::setw(12) << r3[i3]
              << "  " << std::setw(12) << a3[0+i3*m]
              << "  " << std::setw(12) << a3[1+i3*m] << "\n";
  }
  std::cout << "\n";
  std::cout << "          I3   INDX3   R3(INDX3)\n";
  std::cout << "\n";
  for ( i3 = 0; i3 < n3; i3++ )
  {
    std::cout << "  " << "    "
              << "  " << std::setw(4) << i3
              << "  " << std::setw(4) << indx3[i3]
              << "  " << std::setw(12) << r3[indx3[i3]] << "\n";
  }

  delete [] a3;
  delete [] indx1;
  delete [] indx2;
  delete [] indx3;
  delete [] r1;
  delete [] r2;
  delete [] r3;
  delete [] undx1;
  delete [] undx2;
  delete [] undx3;
  delete [] unique1;
  delete [] unique2;
  delete [] unique3;
  delete [] xdnu1;
  delete [] xdnu2;
  delete [] xdnu3;
  delete [] z;

  return;
# undef M
# undef N1
# undef N2
}
//****************************************************************************80

void test29 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST29 tests R8COL_TOL_UNDEX.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    19 July 2010
//
//  Author:
//
//    John Burkardt
//
{
# define M 3
# define N 22

  double a[M*N] = {
    1.9,  0.0, 10.0, 
    2.0,  6.0, 10.0, 
    4.0,  8.0, 12.0, 
    1.0,  5.0,  9.0, 
    3.0,  7.0, 11.0, 
    2.0,  6.0,  0.0, 
    2.0,  0.0, 10.1, 
    2.0,  0.1, 10.0, 
    3.0,  4.0, 18.0, 
    1.9,  8.0, 10.0, 
    0.0,  0.0,  0.0, 
    0.0,  6.0, 10.0, 
    2.1,  0.0, 10.0, 
    2.0,  6.0, 10.0, 
    3.0,  7.0, 11.0, 
    2.0,  0.0, 10.0, 
    2.0,  0.0, 10.0, 
    2.0,  6.0, 10.0, 
    1.0,  5.0,  9.0, 
    2.0,  0.0, 10.1, 
    1.0,  5.0,  9.1, 
    1.0,  5.1,  9.0 };
  double *au;
  int i;
  int j;
  int j2;
  int m = M;
  int n = N;
  int n_unique;
  double tol;
  int *undx;
  int unique_num;
  int *xdnu;

  std::cout << "\n";
  std::cout << "TEST29\n";
  std::cout << "  R8COL_TOL_UNDEX produces index vectors which create a sorted\n";
  std::cout << "  list of the tolerably unique columns of an R8COL,\n";
  std::cout << "  and a map from the original R8COL to the (implicit)\n";
  std::cout << "  R8COL of sorted tolerably unique elements.\n";

  webbur::r8mat_transpose_print ( m, n, a, "  The unsorted R8COL (transposed):" );

  tol = 0.25;

  std::cout << "\n";
  std::cout << "  Using tolerance = " << tol << "\n";

  n_unique = webbur::r8col_tol_unique_count ( m, n, a, tol );

  std::cout << "\n";
  std::cout << "  Number of tolerably unique columns is " << n_unique << "\n";

  au = new double[m*n_unique];
  undx = new int[n_unique];
  xdnu = new int[n];

  webbur::r8col_tol_undex ( m, n, a, n_unique, tol, undx, xdnu );

  std::cout << "\n";
  std::cout << "  XDNU points to the representative for each item.\n";
  std::cout << "  UNDX selects the representatives.\n";
  std::cout << "\n";
  std::cout << "     I  XDNU  UNDX\n";
  std::cout << "\n";
  for ( i = 0; i < n_unique; i++ )
  {
    std::cout << "  " << std::setw(4) << i
              << "  " << std::setw(4) << xdnu[i]
              << "  " << std::setw(4) << undx[i] << "\n";
  }
  for ( i = n_unique; i < n; i++ )
  {
    std::cout << "  " << std::setw(4) << i
              << "  " << std::setw(4) << xdnu[i] << "\n";
  }

  for ( j = 0; j < n_unique; j++ )
  {
    for ( i = 0; i < m; i++ )
    {
      au[i+j*m] = a[i+undx[j]*m];
    }
  }

  webbur::r8mat_transpose_print ( m, n_unique, au, 
    "  The tolerably unique R8COL (transposed):" );

  delete [] au;
  delete [] undx;
  delete [] xdnu;

  return;
# undef M
# undef N
}
//****************************************************************************80

void test30 ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST30 tests R8VEC_SORT_HEAP_INDEX_A_NEW.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    02 October 2010
//
//  Author:
//
//    John Burkardt
//
{
  double *a;
  double *b;
  int i;
  int *indx;
  int n = 20;
  int seed;

  std::cout << "\n";
  std::cout << "TEST30\n";
  std::cout << "  R8VEC_SORT_HEAP_INDEX_A_NEW creates an ascending\n";
  std::cout << "  sort index for a R8VEC.\n";

  seed = 123456789;

  a = webbur::r8vec_uniform_01_new ( n, &seed );

  webbur::r8vec_print ( n, a, "  The unsorted array:" );

  indx = webbur::r8vec_sort_heap_index_a_new ( n, a );

  webbur::i4vec_print ( n, indx, "  The index vector:" );

  b = new double[n];

  for ( i = 0; i < n; i++ )
  {
    b[i] = a[indx[i]];
  }

  webbur::r8vec_print ( n, b, "  The sorted array A(INDX(:)):" );

  delete [] a;
  delete [] b;
  delete [] indx;
}
//****************************************************************************80

void test01_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST01_NP tests CHEBYSHEV1_COMPUTE_NP against CHEBYSHEV1_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST01\n";
  std::cout << "  CHEBYSHEV1_COMPUTE_NP computes a Gauss-Chebyshev type 1 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) / sqrt ( 1 - x^2 ) dx.\n";
  std::cout << "\n";
  std::cout << "  CHEBYSHEV1_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::chebyshev1_compute_np ( order, np, p, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::chebyshev1_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test02_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST02_NP tests CHEBYSHEV1_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST02\n";
  std::cout << "  CHEBYSHEV1_COMPUTE_NP computes a Gauss-Chebyshev type 1 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) / sqrt(1-x^2) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::chebyshev1_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test03_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST03_NP tests CHEBYSHEV2_COMPUTE_NP against CHEBYSHEV2_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST03\n";
  std::cout << "  CHEBYSHEV2_COMPUTE_NP computes a Gauss-Chebyshev type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) * sqrt ( 1 - x^2 ) dx.\n";
  std::cout << "\n";
  std::cout << "  CHEBYSHEV2_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::chebyshev2_compute_np ( order, np, p, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::chebyshev2_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test04_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST04_NP tests CHEBYSHEV2_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST04\n";
  std::cout << "  CHEBYSHEV2_COMPUTE_NP computes a Gauss-Chebyshev type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) * sqrt(1-x^2) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::chebyshev2_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test05_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST05_NP tests CLENSHAW_CURTIS_COMPUTE_NP against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int n_hi;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST05\n";
  std::cout << "  CLENSHAW_CURTIS_COMPUTE_NP computes a Clenshaw Curtis rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N up to\n";
  std::cout << "    N = ORDER+1 if ORDER is odd, or\n";
  std::cout << "    N = ORDER   if ORDER is even\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::clenshaw_curtis_compute_np ( order, np, p, x, w );

    if ( ( order % 2 ) == 0 )
    {
      n_hi = order + 2;
    }
    else
    {
      n_hi = order + 3;
    }

    for ( n = 0; n <= n_hi; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test06_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST06_NP tests CLENSHAW_CURTIS_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST06\n";
  std::cout << "  CLENSHAW_CURTIS_COMPUTE_NP computes a Clenshaw Curtis rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::clenshaw_curtis_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test07_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST07_NP tests FEJER2_COMPUTE_NP against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int n_hi;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST07\n";
  std::cout << "  FEJER2_COMPUTE_NP computes a Fejer Type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N up to\n";
  std::cout << "    N = ORDER+1 if ORDER is odd, or\n";
  std::cout << "    N = ORDER   if ORDER is even\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::fejer2_compute_np ( order, np, p, x, w );

    if ( ( order % 2 ) == 0 )
    {
      n_hi = order + 2;
    }
    else
    {
      n_hi = order + 3;
    }

    for ( n = 0; n <= n_hi; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test08_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST08_NP tests FEJER2_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST08\n";
  std::cout << "  FEJER2_COMPUTE_NP computes a Fejer Type 2 rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::fejer2_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test09_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST09_NP tests GEGENBAUER_COMPUTE_NP against GEGENBAUER_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 1;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST09\n";
  std::cout << "  GEGENBAUER_COMPUTE_NP computes a generalized Gauss-Gegenbauer rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) (1-x^2)^alpha dx.\n";
  std::cout << "\n";
  std::cout << "  GEGENBAUER_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gegenbauer_compute_np ( order, np, p, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gegenbauer_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test10_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST10_NP tests GEGENBAUER_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST10\n";
  std::cout << "  GEGENBAUER_COMPUTE_NP computes a generalized Gauss-Gegenbauer rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x^2)^alpha dx.\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gegenbauer_compute_np ( order, np, p, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }

  delete [] p;
 
  return;
# undef TEST_NUM
}
//****************************************************************************80

void test11_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST11_NP tests GEN_HERMITE_COMPUTE_NP against GEN_HERMITE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 1;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST11\n";
  std::cout << "  GEN_HERMITE_COMPUTE_NP computes a generalized Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) x^alpha exp(-x*x) dx.\n";
  std::cout << "\n";
  std::cout << "  GEN_HERMITE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gen_hermite_compute_np ( order, np, p, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gen_hermite_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setprecision(6) << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test12_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST12_NP tests GEN_HERMITE_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int np = 1;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST12\n";
  std::cout << "  GEN_HERMITE_COMPUTE_NP computes a generalized Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) x^alpha exp(-x*x) dx.\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gen_hermite_compute_np ( order, np, p, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }
 
  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test13_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST13_NP tests GEN_LAGUERRE_COMPUTE_NP against GEN_LAGUERRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 1;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST13\n";
  std::cout << "  GEN_LAGUERRE_COMPUTE_NP computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) x^alpha exp(-x) dx.\n";
  std::cout << "\n";
  std::cout << "  GEN_LAGUERRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Estimate       Exact            Error\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";

      f = new double[order];
      w = new double[order];
      x = new double[order];

      webbur::gen_laguerre_compute_np ( order, np, p, x, w );
 
      for ( n = 0; n <= 2 * order + 2; n = n + 1 )
      {
        exact = webbur::gen_laguerre_integral ( n, alpha );

        if ( n == 0 )
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = 1.0;
          }
        }
        else
        {
          for ( i = 0; i < order; i++ )
          {
            f[i] = std::pow ( x[i], n );
          }
        }
        estimate = 0.0;
        for ( i = 0; i < order; i++ )
        {
          estimate = estimate + w[i] * f[i];
        }

        error = webbur::r8_abs ( exact - estimate );
  
        std::cout << "  " << std::setw(8)  << order
             << "  " << std::setw(8)  << n
             << "  " << std::setprecision(6) << std::setw(14) << alpha
             << "  " << std::setprecision(6) << std::setw(14) << estimate
             << "  " << std::setprecision(6) << std::setw(14) << exact
             << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
      }
      delete [] f;
      delete [] w;
      delete [] x;
    }
  }
 
  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test14_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST14_NP tests GEN_LAGUERRE_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int np = 1;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST14\n";
  std::cout << "  GEN_LAGUERRE_COMPUTE_NP computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) x^alpha exp(-x) dx.\n";

  p = new double[np];

  for ( test = 0; test < TEST_NUM; test++ )
  {
    alpha = alpha_test[test];
    p[0] = alpha;

    for ( order = 1; order <= order_max; order++ )
    {
      std::cout << "\n";
      std::cout << "  Order = " << order << "\n";
      std::cout << "  ALPHA = " << alpha << "\n";

      w = new double[order];
      x = new double[order];

      webbur::gen_laguerre_compute_np ( order, np, p, x, w );
 
      for ( i = 0; i < order; i =i + 1 )
      {
        std::cout << "  " << std::setw(8) << i
             << "  " << std::setprecision(16) << std::setw(24) << x[i]
             << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
      }
      delete [] w;
      delete [] x;
    }
  }
 
  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test15_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST15_NP tests HERMITE_COMPUTE_NP against HERMITE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST15\n";
  std::cout << "  HERMITE_COMPUTE_NP computes a Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) exp(-x*x) dx.\n";
  std::cout << "\n";
  std::cout << "  HERMITE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::hermite_compute_np ( order, np, p, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::hermite_integral ( n );
 
      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test16_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST16_NP tests HERMITE_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST16\n";
  std::cout << "  HERMITE_COMPUTE_NP computes a Gauss-Hermite rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -oo < x < +oo ) f(x) exp(-x*x) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::hermite_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test17_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST17_NP tests JACOBI_COMPUTE_NP against JACOBI_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double beta;
  double beta_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 2;
  int order;
  int order_max = 10;
  double *p;
  int test1;
  int test2;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST17\n";
  std::cout << "  JACOBI_COMPUTE_NP computes a Gauss-Jacobi rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x)^alpha (1+x)^beta dx.\n";
  std::cout << "\n";
  std::cout << "  JACOBI_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Alpha           Beta            Estimate       Exact            Error\n";

  p = new double[np];

  for ( test1 = 0; test1 < TEST_NUM; test1++ )
  {
    alpha = alpha_test[test1];
    p[0] = alpha;

    for ( test2 = 0; test2 < TEST_NUM; test2++ )
    {
      beta = beta_test[test2];
      p[1] = beta;

      for ( order = 1; order <= order_max; order++ )
      {
        std::cout << "\n";

        f = new double[order];
        w = new double[order];
        x = new double[order];

        webbur::jacobi_compute_np ( order, np, p, x, w );

        for ( n = 0; n <= 2 * order + 2; n = n + 1 )
        {
          exact = webbur::jacobi_integral ( n, alpha, beta );
 
          if ( n == 0 )
          {
            for ( i = 0; i < order; i++ )
            {
              f[i] = 1.0;
            }
          }
          else
          {
            for ( i = 0; i < order; i++ )
            {
              f[i] = std::pow ( x[i], n );
            }
          }
          estimate = 0.0;
          for ( i = 0; i < order; i++ )
          {
            estimate = estimate + w[i] * f[i];
          }
 
          error = webbur::r8_abs ( exact - estimate );
  
          std::cout << "  " << std::setw(8)  << order
               << "  " << std::setw(8)  << n
               << "  " << std::setprecision(6) << std::setw(14) << alpha
               << "  " << std::setprecision(6) << std::setw(14) << beta
               << "  " << std::setprecision(6) << std::setw(14) << estimate
               << "  " << std::setprecision(6) << std::setw(14) << exact
               << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
        }
        delete [] f;
        delete [] w;
        delete [] x;
      }
    }
  }

  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test18_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST18_NP tests JACOBI_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
# define TEST_NUM 3

  double alpha;
  double alpha_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  double beta;
  double beta_test[TEST_NUM] = { 0.5, 1.0, 2.5 };
  int i;
  int np = 2;
  int order;
  int order_max = 10;
  double *p;
  int test1;
  int test2;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST18\n";
  std::cout << "  JACOBI_COMPUTE_NP computes a Gauss-Jacobi rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) (1-x)^alpha (1+x)^beta dx.\n";

  p = new double[np];

  for ( test1 = 0; test1 < TEST_NUM; test1++ )
  {
    alpha = alpha_test[test1];
    p[0] = alpha;

    for ( test2 = 0; test2 < TEST_NUM; test2++ )
    {
      beta = beta_test[test2];
      p[1] = beta;

      for ( order = 1; order <= order_max; order++ )
      {
        std::cout << "\n";
        std::cout << "  Order = " << order << "\n";
        std::cout << "  ALPHA = " << alpha << "\n";
        std::cout << "  BETA = "  << beta << "\n";

        w = new double[order];
        x = new double[order];

        webbur::jacobi_compute_np ( order, np, p, x, w );

        for ( i = 0; i < order; i =i + 1 )
        {
          std::cout << "  " << std::setw(8) << i
               << "  " << std::setprecision(16) << std::setw(24) << x[i]
               << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
        }
        delete [] w;
        delete [] x;
      }
    }
  }

  delete [] p;

  return;
# undef TEST_NUM
}
//****************************************************************************80

void test19_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST19_NP tests LAGUERRE_COMPUTE_NP against LAGUERRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST19\n";
  std::cout << "  LAGUERRE_COMPUTE_NP computes a Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) exp(-x) dx.\n";
  std::cout << "\n";
  std::cout << "  LAGUERRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::laguerre_compute_np ( order, np, p, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::laguerre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test20_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST20_NP tests LAGUERRE_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST20\n";
  std::cout << "  LAGUERRE_COMPUTE_NP computes a generalized Gauss-Laguerre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( 0 <= x < +oo ) f(x) exp(-x) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::laguerre_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
//****************************************************************************80

void test21_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST21_NP tests LEGENDRE_COMPUTE_NP against LEGENDRE_INTEGRAL.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  double error;
  double estimate;
  double exact;
  double *f;
  int i;
  int n;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST21\n";
  std::cout << "  LEGENDRE_COMPUTE_NP computes a Gauss-Legendre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x)  dx.\n";
  std::cout << "\n";
  std::cout << "  LEGENDRE_INTEGRAL determines the exact value of\n";
  std::cout << "  this integal when f(x) = x^n.\n";
  std::cout << "\n";
  std::cout << "  A rule of order ORDER should be exact for monomials X^N\n";
  std::cout << "  up to N = 2*ORDER-1\n";
  std::cout << "\n";
  std::cout << "  In the following table, for each order, the LAST THREE estimates\n";
  std::cout << "  are made on monomials that exceed the exactness limit for the rule.\n";
  std::cout << "\n";
  std::cout << "     Order         N       Estimate       Exact            Error\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";

    f = new double[order];
    w = new double[order];
    x = new double[order];

    webbur::legendre_compute_np ( order, np, p, x, w );

    for ( n = 0; n <= 2 * order + 2; n = n + 1 )
    {
      exact = webbur::legendre_integral ( n );

      if ( n == 0 )
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = 1.0;
        }
      }
      else
      {
        for ( i = 0; i < order; i++ )
        {
          f[i] = std::pow ( x[i], n );
        }
      }
      estimate = 0.0;
      for ( i = 0; i < order; i++ )
      {
        estimate = estimate + w[i] * f[i];
      }

      error = webbur::r8_abs ( exact - estimate );
  
      std::cout << "  " << std::setw(8)  << order
           << "  " << std::setw(8)  << n
           << "  " << std::setprecision(6) << std::setw(14) << estimate
           << "  " << std::setprecision(6) << std::setw(14) << exact
           << "  " << std::setprecision(6) << std::setw(14) << error << "\n";
    }
    delete [] f;
    delete [] w;
    delete [] x;
  }

  delete [] p;

  return;
}
//****************************************************************************80

void test22_np ( )

//****************************************************************************80
//
//  Purpose:
//
//    TEST22_NP tests LEGENDRE_COMPUTE_NP.
//
//  Licensing:
//
//    This code is distributed under the GNU LGPL license. 
//
//  Modified:
//
//    03 June 2009
//
//  Author:
//
//    John Burkardt
//
{
  int i;
  int np = 0;
  int order;
  int order_max = 10;
  double *p;
  int test;
  double *w;
  double *x;

  std::cout << "\n";
  std::cout << "TEST22\n";
  std::cout << "  LEGENDRE_COMPUTE_NP computes a Gauss-Legendre rule\n";
  std::cout << "  which is appropriate for integrands of the form\n";
  std::cout << "    Integral ( -1 <= x <= +1 ) f(x) dx.\n";

  p = new double[np];

  for ( order = 1; order <= order_max; order++ )
  {
    std::cout << "\n";
    std::cout << "  Order = " << order << "\n";

    w = new double[order];
    x = new double[order];

    webbur::legendre_compute_np ( order, np, p, x, w );
 
    for ( i = 0; i < order; i =i + 1 )
    {
      std::cout << "  " << std::setw(8) << i
           << "  " << std::setprecision(16) << std::setw(24) << x[i]
           << "  " << std::setprecision(16) << std::setw(24) << w[i] << "\n";
    }
    delete [] w;
    delete [] x;
  }
 
  delete [] p;

  return;
}
